# react-bootstrap-native-table

It is a fork of react-bootstrap-native-table
Author AllenFang

That 'native' version is using reac-bootstrap.

https://docs.npmjs.com/getting-started/publishing-npm-packages


git pull upstream --rebase master


## Usage
### a.Install
```bash
npm install react-bootstrap-native-table --save
```

### b.Import Module
To use react-bootstrap-native-table in your react app, you should import it first.
You can do this in two ways:

##### With a module bundler
With a module bundler like [webpack](https://webpack.github.io/) that supports either CommonJS or ES2015 modules, use as you would anything else.  
You can include source maps on your build system to debug on development. Don't forget to Uglify on production.

```js
// in ECMAScript 6
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-native-table';
// or in ECMAScript 5
var ReactBSTable = require('react-bootstrap-native-table');  
var BootstrapTable = ReactBSTable.BootstrapTable;
var TableHeaderColumn = ReactBSTable.TableHeaderColumn;
```
##### Browser global(window object)
In the `dist` folder you have a UMD bundle with source maps (`react-bootstrap-native-table.js`) as well as a minified version (`react-bootstrap-native-table.min.js`).

```html
<script src="path/to/react-bootstrap-native-table/dist/react-bootstrap-native-table.min.js" />
<script>
  var ReactBsTable = window.BootstrapTable;
  //...
<script/>
```

The UMD build is also available on [npmcdn](https://npmcdn.com):

```html
// source maps: https://npmcdn.com/react-bootstrap-native-table/dist/react-bootstrap-native-table.js.map
<script src="https://npmcdn.com/react-bootstrap-native-table/dist/react-bootstrap-native-table.js"></script>
// or use the min version
<script src="https://npmcdn.com/react-bootstrap-native-table/dist/react-bootstrap-native-table.min.js"></script>
```

### c.Import CSS
Finally, you need to import the css file to your app, there are two css file you can choose.</br>
```react-bootstrap-native-table-all.min.css``` include toastr.</br>```react-bootstrap-native-table.min.css``` doesn't include toastr.</br>
**Notes: react-bootstrap-native-table use toastr to alarm some message to user.**
```html
<link rel="stylesheet" href="./css/react-bootstrap-native-table-all.min.css">
```
The CSS files you can find in the css folder.

### Quick Demo
```js
// products will be presented by react-bootstrap-native-table
var products = [{
      id: 1,
      name: "Item name 1",
      price: 100
  },{
      id: 2,
      name: "Item name 2",
      price: 100
  },........];
// It's a data format example.
function priceFormatter(cell, row){
  return '<i class="glyphicon glyphicon-usd"></i> ' + cell;
}

React.render(
  <BootstrapTable data={products} striped={true} hover={true}>
      <TableHeaderColumn dataField="id" isKey={true} dataAlign="center" dataSort={true}>Product ID</TableHeaderColumn>
      <TableHeaderColumn dataField="name" dataSort={true}>Product Name</TableHeaderColumn>
      <TableHeaderColumn dataField="price" dataFormat={priceFormatter}>Product Price</TableHeaderColumn>
  </BootstrapTable>,
	document.getElementById("app")
);
```
### More react-bootstrap-native-table examples
The example source codes is in the [examples](https://github.com/AllenFang/react-bootstrap-native-table/tree/master/examples) folder. Run  the following commands for a live demo.</br>
```bash
$ git clone https://github.com/AllenFang/react-bootstrap-native-table.git
$ cd react-bootstrap-native-table
$ npm install
$ gulp example-server #after start, open browser and go to http://localhost:3004
```

### [Documentation](http://allenfang.github.io/react-bootstrap-native-table/docs.html)

### Thanks
**[luqin](https://github.com/luqin)**  
Help this project to integrate a better examples demo, add travis & badge, code formatting, give a lot of suggestions and bugs report.  
**[khinlatt](https://github.com/khinlatt)**  
Contribute export csv, multi-search and bug fixing.  
**[dana](https://github.com/dana2208)**  
Contribute a new colum-filter design and great feedback given.  
**[tbaeg](https://github.com/tbaeg)**  
Bugs report and give some bootstrap and css suggestions actively.  
**[bluedarker](https://github.com/bluedarker)**  
Contribute the edit format & validation on cell editing and row insertion. Improve the custom styling.  
**[Sofia Silva](https://github.com/staminaloops)**  
Bug reports and fixing actively.  
**[frontsideair](https://github.com/frontsideair)**  
Fixing bugs and give improvement for functionality.  
**[aaronhayes](https://github.com/aaronhayes)**  
Bugs report and enhance the cell formatting.  
**[Reggino](https://github.com/Reggino)**  
Implement the TableDataSet component.  

[npm-badge]: http://badge.fury.io/js/react-bootstrap-native-table.svg
[npm]: http://badge.fury.io/js/react-bootstrap-native-table

[deps-badge]: https://david-dm.org/AllenFang/react-bootstrap-native-table.svg
[deps]: https://david-dm.org/AllenFang/react-bootstrap-native-table

[dev-deps-badge]: https://david-dm.org/AllenFang/react-bootstrap-native-table/dev-status.svg
[dev-deps]: https://david-dm.org/AllenFang/react-bootstrap-native-table#info=devDependencies

[peer-deps-badge]: https://david-dm.org/AllenFang/react-bootstrap-native-table/peer-status.svg
[peer-deps]: https://david-dm.org/AllenFang/react-bootstrap-native-table#info=peerDependencies

[travis-ci-image]: https://travis-ci.org/AllenFang/react-bootstrap-native-table.svg
[travis-ci-url]: https://travis-ci.org/AllenFang/react-bootstrap-native-table
